=== examples/libf3d/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)

project(libf3d-examples)

add_subdirectory(cpp)
