=== debian/changelog ===
f3d (2.5.1+dfsg-1) unstable; urgency=medium

  * New upstream version.

 -- Francois Mazen <mzf@debian.org>  Mon, 23 Dec 2024 18:23:56 +0100
